diff --git a/pidgin/gtkconv.c b/pidgin/gtkconv.c
--- a/pidgin/gtkconv.c
+++ b/pidgin/gtkconv.c
@@ -45,7 +45,6 @@
 
 #include "gtkblist.h"
 #include "gtkconv.h"
-#include "gtkconvwin.h"
 #include "gtkdialogs.h"
 #include "gtkprivacy.h"
 #include "gtkutils.h"
@@ -90,10 +89,6 @@
 	GtkWidget *topic_text;
 };
 
-#define CLOSE_CONV_TIMEOUT_SECS  (10 * 60)
-
-#define AUTO_RESPONSE "&lt;AUTO-REPLY&gt; : "
-
 typedef enum
 {
 	PIDGIN_CONV_SET_TITLE			= 1 << 0,
@@ -104,32 +99,12 @@
 	PIDGIN_CONV_COLORIZE_TITLE		= 1 << 6,
 }PidginConvFields;
 
-enum {
-	CONV_ICON_COLUMN,
-	CONV_TEXT_COLUMN,
-	CONV_EMBLEM_COLUMN,
-	CONV_PROTOCOL_ICON_COLUMN,
-	CONV_NUM_COLUMNS
-} PidginInfopaneColumns;
-
 #define	PIDGIN_CONV_ALL	((1 << 7) - 1)
 
-/* XXX: These color defines shouldn't really be here. But the nick-color
- * generation algorithm uses them, so keeping these around until we fix that. */
-#define DEFAULT_SEND_COLOR "#204a87"
-#define DEFAULT_HIGHLIGHT_COLOR "#AF7F00"
-
 #define BUDDYICON_SIZE_MIN    32
 #define BUDDYICON_SIZE_MAX    96
 
-/* These probably won't conflict with any WebKit values. */
-#define PIDGIN_DRAG_BLIST_NODE (1337)
-#define PIDGIN_DRAG_IM_CONTACT (31337)
-
 static GtkWidget *invite_dialog = NULL;
-static GtkWidget *warn_close_dialog = NULL;
-
-static GList *window_list = NULL;
 
 /* Prototypes. <-- because Paco-Paco hates this comment. */
 static void got_typing_keypress(PidginConversation *gtkconv, gboolean first);
@@ -141,11 +116,8 @@
 static void update_typing_icon(PidginConversation *gtkconv);
 gboolean pidgin_conv_has_focus(PurpleConversation *conv);
 static void pidgin_conv_update_fields(PurpleConversation *conv, PidginConvFields fields);
-static void focus_out_from_menubar(GtkWidget *wid, PidginConvWindow *win);
-static void pidgin_conv_tab_pack(PidginConvWindow *win, PidginConversation *gtkconv);
-
-static void pidgin_conv_set_position_size(PidginConvWindow *win, int x, int y,
-		int width, int height);
+
+static void pidgin_conv_placement_place(PidginConversation *conv);
 
 /**************************************************************************
  * Callbacks
@@ -156,6 +128,7 @@
 {
 	PidginConversation *gtkconv = data;
 	GList *list = g_list_copy(gtkconv->convs);
+	purple_debug_misc("gtkconv", "closing %s", purple_conversation_get_name(list->data));
 	g_list_free_full(list, g_object_unref);
 	return FALSE;
 }
@@ -504,80 +477,11 @@
 	gtk_widget_show_all(invite_dialog);
 }
 
-static void
-savelog_writefile_cb(void *user_data, const char *filename)
-{
-	PurpleConversation *conv = (PurpleConversation *)user_data;
-	PidginConversation *gtkconv = PIDGIN_CONVERSATION(conv);
-	GtkTextBuffer *buffer = NULL;
-	FILE *fp;
-	const char *name;
-	gchar *text;
-
-	if ((fp = g_fopen(filename, "w+")) == NULL) {
-		purple_notify_error(PIDGIN_CONVERSATION(conv), NULL,
-			_("Unable to open file."), NULL,
-			purple_request_cpar_from_conversation(conv));
-		return;
-	}
-
-	name = purple_conversation_get_name(conv);
-
-	fprintf(fp, "<html>\n");
-	fprintf(fp, "<head>\n");
-	fprintf(fp, "<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">\n");
-	fprintf(fp, "<title>%s</title>\n", name);
-	fprintf(fp, "</head>\n");
-
-	fprintf(fp, "<body>\n");
-	fprintf(fp, _("<h1>Conversation with %s</h1>\n"), name);
-	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(gtkconv->history));
-	text = talkatu_markup_get_html(buffer, NULL);
-	fprintf(fp, "%s", text);
-	g_free(text);
-	fprintf(fp, "\n</body>\n");
-
-	fprintf(fp, "</html>\n");
-	fclose(fp);
-}
-
-/*
- * It would be kinda cool if this gave the option of saving a
- * plaintext v. HTML file.
- */
-static void
-menu_save_as_cb(GtkAction *action, gpointer data)
-{
-	PidginConvWindow *win = data;
-	PurpleConversation *conv = pidgin_conv_window_get_active_conversation(win);
-	PurpleAccount *account = purple_conversation_get_account(conv);
-	PurpleBuddy *buddy = purple_blist_find_buddy(account, purple_conversation_get_name(conv));
-	const char *name;
-	gchar *buf;
-	gchar *c;
-
-	if (buddy != NULL)
-		name = purple_buddy_get_contact_alias(buddy);
-	else
-		name = purple_normalize(account, purple_conversation_get_name(conv));
-
-	buf = g_strdup_printf("%s.html", name);
-	for (c = buf ; *c ; c++)
-	{
-		if (*c == '/' || *c == '\\')
-			*c = ' ';
-	}
-	purple_request_file(PIDGIN_CONVERSATION(conv), _("Save Conversation"),
-		buf, TRUE, G_CALLBACK(savelog_writefile_cb), NULL,
-		purple_request_cpar_from_conversation(conv), conv);
-
-	g_free(buf);
-}
-
 #ifdef USE_VV
 static void
 menu_initiate_media_call_cb(GtkAction *action, gpointer data)
 {
+#if 0
 	PidginConvWindow *win = (PidginConvWindow *)data;
 	PurpleConversation *conv = pidgin_conv_window_get_active_conversation(win);
 	PurpleAccount *account = purple_conversation_get_account(conv);
@@ -588,14 +492,15 @@
 			action == win->menu->video_call ? PURPLE_MEDIA_VIDEO :
 			action == win->menu->audio_video_call ? PURPLE_MEDIA_AUDIO |
 			PURPLE_MEDIA_VIDEO : PURPLE_MEDIA_NONE);
+#endif
 }
 #endif
 
 static void
 menu_send_file_cb(GtkAction *action, gpointer data)
 {
-	PidginConvWindow *win = data;
-	PurpleConversation *conv = pidgin_conv_window_get_active_conversation(win);
+	PidginConversationWindow *win = data;
+	PurpleConversation *conv = pidgin_conversation_window_get_selected(win);
 
 	if (PURPLE_IS_IM_CONVERSATION(conv)) {
 		purple_serv_send_file(purple_conversation_get_connection(conv), purple_conversation_get_name(conv), NULL);
@@ -606,12 +511,12 @@
 static void
 menu_alias_cb(GtkAction *action, gpointer data)
 {
-	PidginConvWindow *win = data;
+	PidginConversationWindow *win = data;
 	PurpleConversation *conv;
 	PurpleAccount *account;
 	const char *name;
 
-	conv    = pidgin_conv_window_get_active_conversation(win);
+	conv    = pidgin_conversation_window_get_selected(win);
 	account = purple_conversation_get_account(conv);
 	name    = purple_conversation_get_name(conv);
 
@@ -633,10 +538,10 @@
 static void
 menu_get_info_cb(GtkAction *action, gpointer data)
 {
-	PidginConvWindow *win = data;
+	PidginConversationWindow *win = data;
 	PurpleConversation *conv;
 
-	conv = pidgin_conv_window_get_active_conversation(win);
+	conv = pidgin_conversation_window_get_selected(win);
 
 	info_cb(NULL, PIDGIN_CONVERSATION(conv));
 }
@@ -644,10 +549,10 @@
 static void
 menu_invite_cb(GtkAction *action, gpointer data)
 {
-	PidginConvWindow *win = data;
+	PidginConversationWindow *win = data;
 	PurpleConversation *conv;
 
-	conv = pidgin_conv_window_get_active_conversation(win);
+	conv = pidgin_conversation_window_get_selected(win);
 
 	invite_cb(NULL, PIDGIN_CONVERSATION(conv));
 }
@@ -655,10 +560,10 @@
 static void
 menu_block_cb(GtkAction *action, gpointer data)
 {
-	PidginConvWindow *win = data;
+	PidginConversationWindow *win = data;
 	PurpleConversation *conv;
 
-	conv = pidgin_conv_window_get_active_conversation(win);
+	conv = pidgin_conversation_window_get_selected(win);
 
 	block_cb(NULL, PIDGIN_CONVERSATION(conv));
 }
@@ -666,10 +571,10 @@
 static void
 menu_unblock_cb(GtkAction *action, gpointer data)
 {
-	PidginConvWindow *win = data;
+	PidginConversationWindow *win = data;
 	PurpleConversation *conv;
 
-	conv = pidgin_conv_window_get_active_conversation(win);
+	conv = pidgin_conversation_window_get_selected(win);
 
 	unblock_cb(NULL, PIDGIN_CONVERSATION(conv));
 }
@@ -677,10 +582,10 @@
 static void
 menu_add_remove_cb(GtkAction *action, gpointer data)
 {
-	PidginConvWindow *win = data;
+	PidginConversationWindow *win = data;
 	PurpleConversation *conv;
 
-	conv = pidgin_conv_window_get_active_conversation(win);
+	conv = pidgin_conversation_window_get_selected(win);
 
 	add_remove_cb(NULL, PIDGIN_CONVERSATION(conv));
 }
@@ -688,9 +593,9 @@
 static void
 menu_close_conv_cb(GtkAction *action, gpointer data)
 {
-	PidginConvWindow *win = data;
-
-	close_conv_cb(NULL, PIDGIN_CONVERSATION(pidgin_conv_window_get_active_conversation(win)));
+	PidginConversationWindow *win = data;
+
+	close_conv_cb(NULL, PIDGIN_CONVERSATION(pidgin_conversation_window_get_selected(win)));
 }
 
 static void
@@ -1039,43 +944,6 @@
 	g_free(who);
 }
 
-static void
-move_to_next_unread_tab(PidginConversation *gtkconv, gboolean forward)
-{
-	PidginConversation *next_gtkconv = NULL, *most_active = NULL;
-	PidginUnseenState unseen_state = PIDGIN_UNSEEN_NONE;
-	PidginConvWindow *win;
-	int initial, i, total, diff;
-
-	win   = gtkconv->win;
-	initial = gtk_notebook_page_num(GTK_NOTEBOOK(win->notebook),
-	                                gtkconv->tab_cont);
-	total = pidgin_conv_window_get_gtkconv_count(win);
-	/* By adding total here, the moduli calculated later will always have two
-	 * positive arguments. x % y where x < 0 is not guaranteed to return a
-	 * positive number.
-	 */
-	diff = (forward ? 1 : -1) + total;
-
-	for (i = (initial + diff) % total; i != initial; i = (i + diff) % total) {
-		next_gtkconv = pidgin_conv_window_get_gtkconv_at_index(win, i);
-		if (next_gtkconv->unseen_state > unseen_state) {
-			most_active = next_gtkconv;
-			unseen_state = most_active->unseen_state;
-			if(PIDGIN_UNSEEN_NICK == unseen_state) /* highest possible state */
-				break;
-		}
-	}
-
-	if (most_active == NULL) { /* no new messages */
-		i = (i + diff) % total;
-		most_active = pidgin_conv_window_get_gtkconv_at_index(win, i);
-	}
-
-	if (most_active != NULL && most_active != gtkconv)
-		pidgin_conv_window_switch_gtkconv(win, most_active);
-}
-
 static gboolean
 gtkconv_cycle_focus(PidginConversation *gtkconv, GtkDirectionType dir)
 {
@@ -1164,11 +1032,11 @@
 static gboolean
 conv_keypress_common(PidginConversation *gtkconv, GdkEventKey *event)
 {
-	PidginConvWindow *win;
-	int curconv;
-
-	win     = gtkconv->win;
-	curconv = gtk_notebook_get_current_page(GTK_NOTEBOOK(win->notebook));
+	PidginConversationWindow *convwin;
+	GtkWidget *win;
+
+	win = gtk_widget_get_toplevel(gtkconv->tab_cont);
+	convwin = PIDGIN_CONVERSATION_WINDOW(win);
 
 	/* If CTRL was held down... */
 	if (event->state & GDK_CONTROL_MASK) {
@@ -1176,48 +1044,17 @@
 			case GDK_KEY_Page_Down:
 			case GDK_KEY_KP_Page_Down:
 			case ']':
-				if (!pidgin_conv_window_get_gtkconv_at_index(win, curconv + 1))
-					gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), 0);
-				else
-					gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), curconv + 1);
+				pidgin_conversation_window_select_next(convwin);
 				return TRUE;
 				break;
 
 			case GDK_KEY_Page_Up:
 			case GDK_KEY_KP_Page_Up:
 			case '[':
-				if (!pidgin_conv_window_get_gtkconv_at_index(win, curconv - 1))
-					gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), -1);
-				else
-					gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), curconv - 1);
+				pidgin_conversation_window_select_previous(convwin);
 				return TRUE;
 				break;
 
-			case GDK_KEY_Tab:
-			case GDK_KEY_KP_Tab:
-			case GDK_KEY_ISO_Left_Tab:
-				if (event->state & GDK_SHIFT_MASK) {
-					move_to_next_unread_tab(gtkconv, FALSE);
-				} else {
-					move_to_next_unread_tab(gtkconv, TRUE);
-				}
-
-				return TRUE;
-				break;
-
-			case GDK_KEY_comma:
-				gtk_notebook_reorder_child(GTK_NOTEBOOK(win->notebook),
-						gtk_notebook_get_nth_page(GTK_NOTEBOOK(win->notebook), curconv),
-						curconv - 1);
-				return TRUE;
-				break;
-
-			case GDK_KEY_period:
-				gtk_notebook_reorder_child(GTK_NOTEBOOK(win->notebook),
-						gtk_notebook_get_nth_page(GTK_NOTEBOOK(win->notebook), curconv),
-						(curconv + 1) % gtk_notebook_get_n_pages(GTK_NOTEBOOK(win->notebook)));
-				return TRUE;
-				break;
 			case GDK_KEY_F6:
 				if (gtkconv_cycle_focus(gtkconv, event->state & GDK_SHIFT_MASK ? GTK_DIR_TAB_BACKWARD : GTK_DIR_TAB_FORWARD))
 					return TRUE;
@@ -1231,8 +1068,7 @@
 		if (event->keyval > '0' && event->keyval <= '9')
 		{
 			guint switchto = event->keyval - '1';
-			if (switchto < pidgin_conv_window_get_gtkconv_count(win))
-				gtk_notebook_set_current_page(GTK_NOTEBOOK(win->notebook), switchto);
+			pidgin_conversation_window_select_nth(convwin, switchto);
 
 			return TRUE;
 		}
@@ -1397,14 +1233,12 @@
 	gray_stuff_out(gtkconv);
 	update_typing_icon(gtkconv);
 	g_object_set_data(G_OBJECT(gtkconv->entry), "transient_buddy", NULL);
-
-	gtk_window_set_title(GTK_WINDOW(gtkconv->win->window),
-	                     gtk_label_get_text(GTK_LABEL(gtkconv->tab_label)));
 }
 
 void
 pidgin_conv_present_conversation(PurpleConversation *conv)
 {
+#if 0
 	PidginConversation *gtkconv;
 	GdkModifierType state;
 
@@ -1417,6 +1251,7 @@
 	if (gtk_get_current_event_state(&state))
 		pidgin_conv_window_switch_gtkconv(gtkconv->win, gtkconv);
 	gtk_window_present(GTK_WINDOW(gtkconv->win->window));
+#endif
 }
 
 static GList *
@@ -1460,83 +1295,11 @@
 	return ret;
 }
 
-static void
-unseen_conv_menu_cb(GtkMenuItem *item, PurpleConversation *conv)
-{
-	g_return_if_fail(conv != NULL);
-	pidgin_conv_present_conversation(conv);
-}
-
-static void
-unseen_all_conv_menu_cb(GtkMenuItem *item, GList *list)
-{
-	g_return_if_fail(list != NULL);
-	/* Do not free the list from here. It will be freed from the
-	 * 'destroy' callback on the menuitem. */
-	while (list) {
-		pidgin_conv_present_conversation(list->data);
-		list = list->next;
-	}
-}
-
-guint
-pidgin_conversations_fill_menu(GtkWidget *menu, GList *convs)
-{
-	GList *l;
-	guint ret=0;
-
-	g_return_val_if_fail(menu != NULL, 0);
-	g_return_val_if_fail(convs != NULL, 0);
-
-	for (l = convs; l != NULL ; l = l->next) {
-		PurpleConversation *conv = (PurpleConversation*)l->data;
-		PidginConversation *gtkconv = PIDGIN_CONVERSATION(conv);
-		GtkWidget *icon = NULL;
-		GtkWidget *item;
-		gchar *text = g_strdup_printf("%s (%d)",
-				gtk_label_get_text(GTK_LABEL(gtkconv->tab_label)),
-				gtkconv->unseen_count);
-
-		icon = pidgin_presence_icon_new(NULL, "chat",
-		                                GTK_ICON_SIZE_MENU);
-
-		item = gtk_image_menu_item_new_with_label(text);
-		gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(item), icon);
-		g_signal_connect(G_OBJECT(item), "activate", G_CALLBACK(unseen_conv_menu_cb), conv);
-		gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
-		g_free(text);
-		ret++;
-	}
-
-	if (convs->next) {
-		/* There are more than one conversation. Add an option to show all conversations. */
-		GtkWidget *item;
-		GList *list = g_list_copy(convs);
-
-		pidgin_separator(menu);
-
-		item = gtk_menu_item_new_with_label(_("Show All"));
-		g_signal_connect(G_OBJECT(item), "activate", G_CALLBACK(unseen_all_conv_menu_cb), list);
-		g_signal_connect_swapped(G_OBJECT(item), "destroy", G_CALLBACK(g_list_free), list);
-		gtk_menu_shell_append(GTK_MENU_SHELL(menu), item);
-	}
-
-	return ret;
-}
-
-PidginConvWindow *
-pidgin_conv_get_window(PidginConversation *gtkconv)
-{
-	g_return_val_if_fail(gtkconv != NULL, NULL);
-	return gtkconv->win;
-}
-
 static GtkActionEntry menu_entries[] =
 /* TODO: fill out tooltips... */
 {
 	/* Conversation menu */
 	{ "ConversationMenu", NULL, N_("_Conversation"), NULL, NULL, NULL },
-	{ "SaveAs", NULL, N_("_Save As..."), NULL, NULL, G_CALLBACK(menu_save_as_cb) },
 
 #ifdef USE_VV
 	{ "MediaMenu", NULL, N_("M_edia"), NULL, NULL, NULL },
@@ -1559,171 +1322,6 @@
 	{ "Close", NULL, N_("_Close"), "<control>W", NULL, G_CALLBACK(menu_close_conv_cb) },
 };
 
-static const char *conversation_menu =
-"<ui>"
-	"<menubar name='Conversation'>"
-		"<menu action='ConversationMenu'>"
-			"<menuitem action='SaveAs'/>"
-			"<separator/>"
-#ifdef USE_VV
-			"<menu action='MediaMenu'>"
-				"<menuitem action='AudioCall'/>"
-				"<menuitem action='VideoCall'/>"
-				"<menuitem action='AudioVideoCall'/>"
-			"</menu>"
-#endif
-			"<menuitem action='SendFile'/>"
-			"<menuitem action='GetInfo'/>"
-			"<menuitem action='Invite'/>"
-			"<separator/>"
-			"<menuitem action='Alias'/>"
-			"<menuitem action='Block'/>"
-			"<menuitem action='Unblock'/>"
-			"<menuitem action='Add'/>"
-			"<menuitem action='Remove'/>"
-			"<separator/>"
-			"<menuitem action='InsertLink'/>"
-			"<menuitem action='InsertImage'/>"
-			"<separator/>"
-			"<menuitem action='Close'/>"
-		"</menu>"
-	"</menubar>"
-"</ui>";
-
-static void menubar_activated(GtkWidget *item, gpointer data)
-{
-	PidginConvWindow *win = data;
-
-	/* The following are to make sure the 'More' submenu is not regenerated every time
-	 * the focus shifts from 'Conversations' to some other menu and back. */
-	g_signal_handlers_block_by_func(G_OBJECT(item), G_CALLBACK(menubar_activated), data);
-	g_signal_connect(G_OBJECT(win->menu->menubar), "deactivate", G_CALLBACK(focus_out_from_menubar), data);
-}
-
-static void
-focus_out_from_menubar(GtkWidget *wid, PidginConvWindow *win)
-{
-	/* The menubar has been deactivated. Make sure the 'More' submenu is regenerated next time
-	 * the 'Conversation' menu pops up. */
-	GtkWidget *menuitem = gtk_ui_manager_get_widget(win->menu->ui, "/Conversation/ConversationMenu");
-	g_signal_handlers_unblock_by_func(G_OBJECT(menuitem), G_CALLBACK(menubar_activated), win);
-	g_signal_handlers_disconnect_by_func(G_OBJECT(win->menu->menubar),
-				G_CALLBACK(focus_out_from_menubar), win);
-}
-
-static GtkWidget *
-setup_menubar(PidginConvWindow *win)
-{
-	GtkAccelGroup *accel_group;
-	GtkActionGroup *action_group;
-	GError *error = NULL;
-	GtkWidget *menuitem;
-
-	action_group = gtk_action_group_new("ConversationActions");
-	gtk_action_group_set_translation_domain(action_group, PACKAGE);
-	gtk_action_group_add_actions(action_group,
-	                             menu_entries,
-	                             G_N_ELEMENTS(menu_entries),
-	                             win);
-
-	win->menu->ui = gtk_ui_manager_new();
-	gtk_ui_manager_insert_action_group(win->menu->ui, action_group, 0);
-
-	accel_group = gtk_ui_manager_get_accel_group(win->menu->ui);
-	gtk_window_add_accel_group(GTK_WINDOW(win->window), accel_group);
-	g_signal_connect(G_OBJECT(accel_group), "accel-changed",
-	                 G_CALLBACK(pidgin_save_accels_cb), NULL);
-
-	error = NULL;
-	if (!gtk_ui_manager_add_ui_from_string(win->menu->ui, conversation_menu, -1, &error))
-	{
-		g_message("building menus failed: %s", error->message);
-		g_error_free(error);
-		exit(EXIT_FAILURE);
-	}
-
-	win->menu->menubar =
-		gtk_ui_manager_get_widget(win->menu->ui, "/Conversation");
-
-	/* Make sure the 'Conversation ⇨ More' menuitems are regenerated whenever
-	 * the 'Conversation' menu pops up because the entries can change after the
-	 * conversation is created. */
-	menuitem = gtk_ui_manager_get_widget(win->menu->ui, "/Conversation/ConversationMenu");
-	g_signal_connect(G_OBJECT(menuitem), "activate", G_CALLBACK(menubar_activated), win);
-
-#ifdef USE_VV
-	win->menu->audio_call =
-		gtk_ui_manager_get_action(win->menu->ui,
-					    "/Conversation/ConversationMenu/MediaMenu/AudioCall");
-	win->menu->video_call =
-		gtk_ui_manager_get_action(win->menu->ui,
-					    "/Conversation/ConversationMenu/MediaMenu/VideoCall");
-	win->menu->audio_video_call =
-		gtk_ui_manager_get_action(win->menu->ui,
-					    "/Conversation/ConversationMenu/MediaMenu/AudioVideoCall");
-#endif
-
-	/* --- */
-
-	win->menu->send_file =
-		gtk_ui_manager_get_action(win->menu->ui,
-		                          "/Conversation/ConversationMenu/SendFile");
-
-	/* --- */
-
-	win->menu->get_info =
-		gtk_ui_manager_get_action(win->menu->ui,
-		                          "/Conversation/ConversationMenu/GetInfo");
-
-	win->menu->invite =
-		gtk_ui_manager_get_action(win->menu->ui,
-		                          "/Conversation/ConversationMenu/Invite");
-
-	/* --- */
-
-	win->menu->alias =
-		gtk_ui_manager_get_action(win->menu->ui,
-		                          "/Conversation/ConversationMenu/Alias");
-
-	win->menu->block =
-		gtk_ui_manager_get_action(win->menu->ui,
-		                          "/Conversation/ConversationMenu/Block");
-
-	win->menu->unblock =
-		gtk_ui_manager_get_action(win->menu->ui,
-					    "/Conversation/ConversationMenu/Unblock");
-
-	win->menu->add =
-		gtk_ui_manager_get_action(win->menu->ui,
-		                          "/Conversation/ConversationMenu/Add");
-
-	win->menu->remove =
-		gtk_ui_manager_get_action(win->menu->ui,
-		                          "/Conversation/ConversationMenu/Remove");
-
-	/* --- */
-
-	win->menu->insert_link =
-		gtk_ui_manager_get_action(win->menu->ui,
-				"/Conversation/ConversationMenu/InsertLink");
-
-	win->menu->insert_image =
-		gtk_ui_manager_get_action(win->menu->ui,
-				"/Conversation/ConversationMenu/InsertImage");
-
-	/* --- */
-
-	win->menu->tray = pidgin_menu_tray_new();
-	gtk_menu_shell_append(GTK_MENU_SHELL(win->menu->menubar),
-	                      win->menu->tray);
-	gtk_widget_show(win->menu->tray);
-
-	gtk_widget_show(win->menu->menubar);
-
-	return win->menu->menubar;
-}
-
-
 /**************************************************************************
  * Utility functions
  **************************************************************************/
@@ -2422,27 +2020,6 @@
 	return NULL;
 }
 
-static void
-buddy_update_cb(PurpleBlistNode *bnode, gpointer null)
-{
-	GList *list;
-
-	g_return_if_fail(bnode);
-	if (!PURPLE_IS_BUDDY(bnode))
-		return;
-
-	for (list = pidgin_conv_windows_get_list(); list; list = list->next)
-	{
-		PidginConvWindow *win = list->data;
-		PurpleConversation *conv = pidgin_conv_window_get_active_conversation(win);
-
-		if (!PURPLE_IS_IM_CONVERSATION(conv))
-			continue;
-
-		pidgin_conv_update_fields(conv, PIDGIN_CONV_MENU);
-	}
-}
-
 static gboolean
 ignore_middle_click(GtkWidget *widget, GdkEventButton *e, gpointer null)
 {
@@ -2462,10 +2039,10 @@
 private_gtkconv_new(PurpleConversation *conv, gboolean hidden)
 {
 	PidginConversation *gtkconv;
-	GtkWidget *pane = NULL;
-	GtkWidget *tab_cont;
+	GtkWidget *tab_cont, *pane;
 
 	if (PURPLE_IS_IM_CONVERSATION(conv) && (gtkconv = pidgin_conv_find_gtkconv(conv))) {
+		purple_debug_misc("gtkconv", "found existing gtkconv %p", gtkconv);
 		g_object_set_data(G_OBJECT(conv), "pidgin", gtkconv);
 		if (!g_list_find(gtkconv->convs, conv))
 			gtkconv->convs = g_list_prepend(gtkconv->convs, conv);
@@ -2473,6 +2050,7 @@
 		return;
 	}
 
+	purple_debug_misc("creating new gtkconv for %p", conv);
 	gtkconv = g_new0(PidginConversation, 1);
 	g_object_set_data(G_OBJECT(conv), "pidgin", gtkconv);
 	gtkconv->active_conv = conv;
@@ -2533,6 +2111,25 @@
 				"conversation-displayed", PIDGIN_CONVERSATION(conv));
 }
 
+void
+pidgin_conversation_detach(PurpleConversation *conv) {
+	if(PIDGIN_IS_PIDGIN_CONVERSATION(conv)) {
+		PidginConversation *gtkconv = PIDGIN_CONVERSATION(conv);
+
+		close_conv_cb(NULL, gtkconv);
+
+		if (PURPLE_IS_CHAT_CONVERSATION(conv)) {
+			g_free(gtkconv->u.chat);
+		} else if (PURPLE_IS_IM_CONVERSATION(conv)) {
+			g_free(gtkconv->u.im);
+		}
+
+		g_free(gtkconv);
+
+		g_object_set_data(G_OBJECT(conv), "pidgin", NULL);
+	}
+}
+
 static void
 received_im_msg_cb(PurpleAccount *account, char *sender, char *message,
 				   PurpleConversation *conv, PurpleMessageFlags flags)
@@ -2553,6 +2150,7 @@
 pidgin_conv_destroy(PurpleConversation *conv)
 {
 	PidginConversation *gtkconv = PIDGIN_CONVERSATION(conv);
+	GtkWidget *win;
 
 	gtkconv->convs = g_list_remove(gtkconv->convs, conv);
 	/* Don't destroy ourselves until all our convos are gone */
@@ -2565,14 +2163,14 @@
 		return;
 	}
 
-	pidgin_conv_window_remove_gtkconv(gtkconv->win, gtkconv);
+	win = gtk_widget_get_toplevel(gtkconv->tab_cont);
+	pidgin_conversation_window_remove(PIDGIN_CONVERSATION_WINDOW(win), conv);
 
 	/* If the "Save Conversation" or "Save Icon" dialogs are open then close them */
 	purple_request_close_with_handle(gtkconv);
 	purple_notify_close_with_handle(gtkconv);
 
 	gtk_widget_destroy(gtkconv->tab_cont);
-	g_object_unref(gtkconv->tab_cont);
 
 	if (PURPLE_IS_IM_CONVERSATION(conv)) {
 		if (gtkconv->u.im->typing_timer != 0)
@@ -2897,15 +2495,16 @@
 pidgin_conv_has_focus(PurpleConversation *conv)
 {
 	PidginConversation *gtkconv = PIDGIN_CONVERSATION(conv);
-	PidginConvWindow *win;
-	gboolean has_focus;
-
-	win = gtkconv->win;
-
-	g_object_get(G_OBJECT(win->window), "has-toplevel-focus", &has_focus, NULL);
-
-	if (has_focus && pidgin_conv_window_is_active_conversation(conv))
-		return TRUE;
+	GtkWidget *win;
+
+	win = gtk_widget_get_toplevel(gtkconv->tab_cont);
+	if(gtk_window_has_toplevel_focus(GTK_WINDOW(win))) {
+		PidginConversationWindow *convwin = PIDGIN_CONVERSATION_WINDOW(win);
+
+		if(pidgin_conversation_window_conversation_is_selected(convwin, conv)) {
+			return TRUE;
+		}
+	}
 
 	return FALSE;
 }
@@ -2918,6 +2517,10 @@
 static void
 gray_stuff_out(PidginConversation *gtkconv)
 {
+/* This will be replaced by managing an action group in the new conversation
+ * window.
+ */
+#if 0
 	PidginConvWindow *win;
 	PurpleConversation *conv = gtkconv->active_conv;
 	PurpleConnection *gc;
@@ -3052,20 +2655,22 @@
 		gtk_action_set_sensitive(win->menu->insert_link, TRUE);
 		gtk_action_set_sensitive(win->menu->insert_image, FALSE);
 	}
+#endif
 }
 
 static void
 pidgin_conv_update_fields(PurpleConversation *conv, PidginConvFields fields)
 {
 	PidginConversation *gtkconv;
-	PidginConvWindow *win;
+	PidginConversationWindow *convwin;
+	GtkWidget *win;
 
 	gtkconv = PIDGIN_CONVERSATION(conv);
 	if (!gtkconv)
 		return;
-	win = pidgin_conv_get_window(gtkconv);
-	if (!win)
-		return;
+
+	win = gtk_widget_get_toplevel(gtkconv->tab_cont);
+	convwin = PIDGIN_CONVERSATION_WINDOW(win);
 
 	if (fields & PIDGIN_CONV_SET_TITLE)
 	{
@@ -3098,16 +2703,9 @@
 			(fields & PIDGIN_CONV_TOPIC))
 	{
 		char *title;
-		PurpleIMConversation *im = NULL;
 		PurpleAccount *account = purple_conversation_get_account(conv);
 		PurpleBuddy *buddy = NULL;
 		char *markup = NULL;
-		AtkObject *accessibility_obj;
-		/* I think this is a little longer than it needs to be but I'm lazy. */
-		char *style;
-
-		if (PURPLE_IS_IM_CONVERSATION(conv))
-			im = PURPLE_IM_CONVERSATION(conv);
 
 		if ((account == NULL) ||
 			!purple_account_is_connected(account) ||
@@ -3155,38 +2753,7 @@
 		if (title != markup)
 			g_free(markup);
 
-		if (!gtk_widget_get_realized(gtkconv->tab_label))
-			gtk_widget_realize(gtkconv->tab_label);
-
-		accessibility_obj = gtk_widget_get_accessible(gtkconv->tab_cont);
-		if (im != NULL &&
-		    purple_im_conversation_get_typing_state(im) == PURPLE_IM_TYPING) {
-			atk_object_set_description(accessibility_obj, _("Typing"));
-			style = "tab-label-typing";
-		} else if (im != NULL &&
-		         purple_im_conversation_get_typing_state(im) == PURPLE_IM_TYPED) {
-			atk_object_set_description(accessibility_obj, _("Stopped Typing"));
-			style = "tab-label-typed";
-		} else if (gtkconv->unseen_state == PIDGIN_UNSEEN_NICK)	{
-			atk_object_set_description(accessibility_obj, _("Nick Said"));
-			style = "tab-label-attention";
-		} else if (gtkconv->unseen_state == PIDGIN_UNSEEN_TEXT)	{
-			atk_object_set_description(accessibility_obj, _("Unread Messages"));
-			if (PURPLE_IS_CHAT_CONVERSATION(gtkconv->active_conv))
-				style = "tab-label-unreadchat";
-			else
-				style = "tab-label-attention";
-		} else if (gtkconv->unseen_state == PIDGIN_UNSEEN_EVENT) {
-			atk_object_set_description(accessibility_obj, _("New Event"));
-			style = "tab-label-event";
-		} else {
-			style = "tab-label";
-		}
-
-		gtk_widget_set_name(gtkconv->tab_label, style);
-		gtk_label_set_text(GTK_LABEL(gtkconv->tab_label), title);
-		gtk_widget_set_state_flags(gtkconv->tab_label, GTK_STATE_FLAG_ACTIVE, TRUE);
-
+#if 0
 		if (gtkconv->unseen_state == PIDGIN_UNSEEN_TEXT ||
 				gtkconv->unseen_state == PIDGIN_UNSEEN_NICK ||
 				gtkconv->unseen_state == PIDGIN_UNSEEN_EVENT) {
@@ -3199,15 +2766,15 @@
 			pango_attr_list_unref(list);
 		} else
 			gtk_label_set_attributes(GTK_LABEL(gtkconv->tab_label), NULL);
-
-		if (pidgin_conv_window_is_active_conversation(conv))
+#endif
+
+		if (pidgin_conversation_window_conversation_is_selected(convwin, conv)) {
+			const char* current_title = gtk_window_get_title(GTK_WINDOW(win));
+			if (current_title == NULL || !purple_strequal(current_title, title)) {
+				gtk_window_set_title(GTK_WINDOW(win), title);
+			}
+
 			update_typing_icon(gtkconv);
-
-		gtk_label_set_text(GTK_LABEL(gtkconv->menu_label), title);
-		if (pidgin_conv_window_is_active_conversation(conv)) {
-			const char* current_title = gtk_window_get_title(GTK_WINDOW(win->window));
-			if (current_title == NULL || !purple_strequal(current_title, title))
-				gtk_window_set_title(GTK_WINDOW(win->window), title);
 		}
 
 		g_free(title);
@@ -3319,130 +2886,20 @@
 void
 pidgin_conv_update_buttons_by_protocol(PurpleConversation *conv)
 {
-	PidginConvWindow *win;
+	PidginConversation *gtkconv;
+	GtkWidget *win;
 
 	if (!PIDGIN_IS_PIDGIN_CONVERSATION(conv))
 		return;
 
-	win = PIDGIN_CONVERSATION(conv)->win;
-
-	if (win != NULL && pidgin_conv_window_is_active_conversation(conv))
-		gray_stuff_out(PIDGIN_CONVERSATION(conv));
-}
-
-int
-pidgin_conv_get_tab_at_xy(PidginConvWindow *win, int x, int y, gboolean *to_right)
-{
-	gint nb_x, nb_y, x_rel, y_rel;
-	GtkNotebook *notebook;
-	GtkWidget *page, *tab;
-	gint i, page_num = -1;
-	gint count;
-	gboolean horiz;
-
-	if (to_right)
-		*to_right = FALSE;
-
-	notebook = GTK_NOTEBOOK(win->notebook);
-
-	gdk_window_get_origin(gtk_widget_get_window(win->notebook), &nb_x, &nb_y);
-	x_rel = x - nb_x;
-	y_rel = y - nb_y;
-
-	horiz = (gtk_notebook_get_tab_pos(notebook) == GTK_POS_TOP ||
-			gtk_notebook_get_tab_pos(notebook) == GTK_POS_BOTTOM);
-
-	count = gtk_notebook_get_n_pages(GTK_NOTEBOOK(notebook));
-
-	for (i = 0; i < count; i++) {
-		GtkAllocation allocation;
-
-		page = gtk_notebook_get_nth_page(GTK_NOTEBOOK(notebook), i);
-		tab = gtk_notebook_get_tab_label(GTK_NOTEBOOK(notebook), page);
-		gtk_widget_get_allocation(tab, &allocation);
-
-		/* Make sure the tab is not hidden beyond an arrow */
-		if (!gtk_widget_is_drawable(tab) && gtk_notebook_get_show_tabs(notebook))
-			continue;
-
-		if (horiz) {
-			if (x_rel >= allocation.x - 6 &&
-					x_rel <= allocation.x + allocation.width + 6) {
-				page_num = i;
-
-				if (to_right && x_rel >= allocation.x + allocation.width/2)
-					*to_right = TRUE;
-
-				break;
-			}
-		} else {
-			if (y_rel >= allocation.y - 6 &&
-					y_rel <= allocation.y + allocation.height + 6) {
-				page_num = i;
-
-				if (to_right && y_rel >= allocation.y + allocation.height/2)
-					*to_right = TRUE;
-
-				break;
-			}
-		}
-	}
-
-	if (page_num == -1) {
-		/* Add after the last tab */
-		page_num = count - 1;
-	}
-
-	return page_num;
-}
-
-static void
-close_on_tabs_pref_cb(const char *name, PurplePrefType type,
-					  gconstpointer value, gpointer data)
-{
-	GList *list;
-	PurpleConversation *conv;
-	PurpleConversationManager *manager;
-	PidginConversation *gtkconv;
-
-	manager = purple_conversation_manager_get_default();
-	list = purple_conversation_manager_get_all(manager);
-	while(list != NULL) {
-		conv = PURPLE_CONVERSATION(list->data);
-
-		if(!PIDGIN_IS_PIDGIN_CONVERSATION(conv)) {
-			list = g_list_delete_link(list, list);
-
-			continue;
-		}
-
-		gtkconv = PIDGIN_CONVERSATION(conv);
-
-		if(value) {
-			gtk_widget_show(gtkconv->close);
-		} else {
-			gtk_widget_hide(gtkconv->close);
-		}
-
-		list = g_list_delete_link(list, list);
-	}
-}
-
-static void
-tab_side_pref_cb(const char *name, PurplePrefType type,
-				 gconstpointer value, gpointer data)
-{
-	GList *gtkwins, *gtkconvs;
-	GtkPositionType pos;
-	PidginConvWindow *gtkwin;
-
-	pos = GPOINTER_TO_INT(value);
-
-	for (gtkwins = pidgin_conv_windows_get_list(); gtkwins != NULL; gtkwins = gtkwins->next) {
-		gtkwin = gtkwins->data;
-		gtk_notebook_set_tab_pos(GTK_NOTEBOOK(gtkwin->notebook), pos&~8);
-		for (gtkconvs = gtkwin->gtkconvs; gtkconvs != NULL; gtkconvs = gtkconvs->next) {
-			pidgin_conv_tab_pack(gtkwin, gtkconvs->data);
+	gtkconv = PIDGIN_CONVERSATION(conv);
+	win = gtk_widget_get_toplevel(gtkconv->tab_cont);
+
+	if(PIDGIN_IS_CONVERSATION_WINDOW(win)) {
+		PidginConversationWindow *convwin = PIDGIN_CONVERSATION_WINDOW(win);
+
+		if(pidgin_conversation_window_conversation_is_selected(convwin, conv)) {
+			gray_stuff_out(PIDGIN_CONVERSATION(conv));
 		}
 	}
 }
